

							LIST P=16F877A
							INCLUDE<P16F877A.INC>
							__CONFIG _PWRTE_ON & _WDT_OFF & _BODEN_OFF & _LVP_OFF & _HS_OSC & _CP_OFF & _DEBUG_OFF & _WRT_OFF & _CPD_OFF


TMP0	EQU		22H
TMP1	EQU		23H
VYBER	EQU		24H


		ORG		00H
		GOTO	INIT

;------------------------------------------------------------------------------

ADPREVOD	
	
		MOVLW 	0x05  			;CEKANI 750uS PRED ZAHAJENIM PREVODU
        MOVWF 	TMP1
        MOVLW 	0x0DD  			;
        MOVWF 	TMP0
        DECFSZ 	TMP0,1			;
        GOTO 	$-1
        DECFSZ 	TMP1,1			;
        GOTO 	$-3
		
		BSF		ADCON0,2		;zahejni prevodu
		BTFSC	ADCON0,2		;zjistovani dokonceni prevodu
		GOTO	$-1				;...
		RETURN

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

VYSILEJL
		
		BSF		STATUS,RP0		;BANKA1	(ADRESL JE V BANCE 1 !!! )		
		MOVF	ADRESL,W		;do W je ulozena informace a MCU ji nasledne odesila pres UART ven
		BCF		STATUS,RP0		;BANKA0
		MOVWF 	TXREG 			;presunout 8-bit hodnotu do registru TXREG (Bank0) => nacteni dat zacina vysilani

CEKEJ
		BSF 	STATUS,RP0 		;BANKA1
		BTFSS 	TXSTA,1 		;pokud TSR==1 tak TSR je prazdne, pokud ne, skoc na CEKEJ
		GOTO 	CEKEJ 			;tyto dva prikazy funguji jako zpozdovaci smycka (abychom si TXREG neustale neprepisovali)
		BCF 	STATUS,RP0 		;BANKA0
		RETURN

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

VYSILEJH		
		MOVF	ADRESH,W		;do W je ulozena informace a MCU ji nasledne odesila pres UART ven
		MOVWF 	TXREG 			;presunout 8-bit hodnotu do registru TXREG (Bank0) => nacteni dat zacina vysilani

CEKEJ1
		BSF 	STATUS,RP0 		;BANKA1
		BTFSS 	TXSTA,1 		;pokud TSR==1 tak TSR je prazdne, pokud ne, skoc na CEKEJ1
		GOTO 	CEKEJ1 			;tyto dva prikazy funguji jako zpozdovaci smycka (abychom si TXREG neustale neprepisovali)
		BCF 	STATUS,RP0 		;BANKA0
		RETURN



;--------------------------------------------------------------------------------------
		
INIT
		BCF 	STATUS,RP0		;BANKA0
		BCF		STATUS,RP1		;BANKA0
		CLRF	PORTA
		CLRF	PORTE
		CLRF	PORTC
		CLRF	PORTB
		BSF		STATUS,RP0		;BANKA 1
		MOVLW	B'00000111'		;INICIALZICAZE PORTU
		MOVWF	CMCON			;
		MOVLW	B'10000000'		;INICIALIZACE AD PREVODNIKU
		MOVWF	ADCON1			;
		MOVLW	B'00111111'		;INICIALIZACE PORTU
		MOVWF	TRISA			;
		MOVLW	B'00000111'		;
		MOVWF	TRISE			;
		MOVLW	B'00000000'		;
		MOVWF	TRISB			;
		
		CLRF	TRISC			;PortC 7,6 pro USART
		MOVLW	B'11000000'		;
		MOVWF	TRISC			;
								
								 
		MOVLW 	D'129'			;konstanta pro vypocet BAUD RATE 
		MOVWF 	SPBRG 			;
								;
		
		MOVLW 	B'00100000' 	;zapnuti TXEN
		MOVWF 	TXSTA			;
		CLRF 	PIE1 			;Vypnout preruseni na periferiich 
		BCF  	STATUS,RP0		;BANKA0

								
		MOVLW 	B'10010000' 	;zapnuti UART portu a prijmu
		MOVWF 	RCSTA
								
;-------------------------------------------------------------------------------------------------------------------------------		

START	BTFSS	PIR1,RCIF		;ceka na prichozi data (dokud neni naplnen RCREG)
		GOTO	START			;
		MOVF	RCREG,0
		MOVWF	VYBER
		MOVWF	PORTB			;zobrazeni prichozich dat na LED
		GOTO	MENU

MENU	
		BTFSC	VYBER,0			;podle prijatych dat zvol kanal k prevodu
		GOTO	PRENOSK0
		BTFSC	VYBER,1	
		GOTO	PRENOSK1
		BTFSC	VYBER,2
		GOTO	PRENOSK2
		BTFSC	VYBER,3
		GOTO	PRENOSK3
		BTFSC	VYBER,4
		GOTO	PRENOSK4
		GOTO	START
	



PRENOSK0

		MOVLW	B'11000001'		; vyber vstupniho kanalu (0) , vyber zdroje CLOCK (INTRC), zapnuti AD
		MOVWF	ADCON0			;...
		CALL	ADPREVOD		;zavolej zahajeni AD prevodu
		CALL	VYSILEJL		;zavolej vysilani LsB
		CALL	VYSILEJH		;zavolej vysilani MsB
		GOTO	START

PRENOSK1

		MOVLW	B'11001001'		; vyber vstupniho kanalu (1) , vyber zdroje CLOCK (INTRC), zapnuti AD
		MOVWF	ADCON0			;...
		CALL	ADPREVOD		;zavolej zahajeni AD prevodu
		CALL	VYSILEJL		;zavolej vysilani LsB
		CALL	VYSILEJH		;zavolej vysilani MsB
		GOTO	START


	


PRENOSK2
PRENOSK3
PRENOSK4	

		GOTO	START


		
		END


